## acl2 8.4dfsg

=== books/build/jenkins/Makefile ===
# ACL2 Makefile Wrapper
#
# ACL2's makefile unfortunately always rebuilds ACL2, even if it's
# already up to date.  For our build server, this isn't a good idea.
# Run this from your top-level acl2 directory.
#
# General usage:
#
# make -f books/build/jenkins/Makefile <target> LISP=<command>
#
# Example usages:
#
# make -f books/build/jenkins/Makefile acl2 LISP=ccl
# make -f books/build/jenkins/Makefile acl2r LISP=ccl
# make -f books/build/jenkins/Makefile saved_acl2p LISP=ccl

ACL2_ALL_SOURCES  := $(wildcard *.lisp)
ACL2_FAKE_SOURCES := acl2-proclaims.lisp acl2r.lisp
ACL2_SOURCES      := $(filter-out $(ACL2_FAKE_SOURCES), $(ACL2_ALL_SOURCES))
ACL2_DEPS         := $(ACL2_SOURCES) GNUmakefile

#.PHONY: acl2c acl2cp acl2cr acl2cpr
.PHONY: acl2 acl2p acl2r acl2pr

#acl2c: saved_acl2c
#acl2cp: saved_acl2cp
#acl2cr: saved_acl2cr
#acl2cpr: saved_acl2cpr

# Note that we don't use &>, because otherwise the process goes on
# immediately, and waiting 100 seconds isn't enough for SBCL builds.

#saved_acl2c: $(ACL2_DEPS)
#	echo "Making ACL2(c) on $(LISP)"
#	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_PAR= ACL2_REAL= > make-acl2.log
#	./books/build/wait.pl make-acl2.log
#	cat make-acl2.log
#	./books/build/wait.pl saved_acl2c
#	ls -lah saved_acl2c

#saved_acl2cp: $(ACL2_DEPS)
#	echo "Making ACL2(cp) on $(LISP)"
#	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_PAR=p ACL2_REAL= > make-acl2.log
#	./books/build/wait.pl make-acl2.log
#	cat make-acl2.log
#	./books/build/wait.pl saved_acl2cp
#	ls -lah saved_acl2cp

#saved_acl2cr: $(ACL2_DEPS)
#	echo "Making ACL2(cr) on $(LISP)"
#	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_PAR= ACL2_REAL=r > make-acl2.log
#	./books/build/wait.pl make-acl2.log
#	cat make-acl2.log
#	./books/build/wait.pl saved_acl2cr
#	ls -lah saved_acl2cr

#saved_acl2cpr: $(ACL2_DEPS)
#	echo "Making ACL2(cpr) on $(LISP)"
#	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS= ACL2_PAR=p ACL2_REAL=r > make-acl2.log
#	./books/build/wait.pl make-acl2.log
#	cat make-acl2.log
#	./books/build/wait.pl saved_acl2cpr
#	ls -lah saved_acl2cpr




acl2:   saved_acl2
acl2p:  saved_acl2p
acl2r:  saved_acl2r
acl2pr: saved_acl2pr

saved_acl2: $(ACL2_DEPS)
	echo "Making ACL2(h) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_PAR= ACL2_REAL= > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2
	ls -lah saved_acl2

saved_acl2p: $(ACL2_DEPS)
	echo "Making ACL2(hp) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_PAR=p ACL2_REAL= > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2p
	ls -lah saved_acl2p

saved_acl2r: $(ACL2_DEPS)
	echo "Making ACL2(hr) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_PAR= ACL2_REAL=r > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2r
	ls -lah saved_acl2r

saved_acl2pr: $(ACL2_DEPS)
	echo "Making ACL2(hpr) on $(LISP)"
	time make --file=GNUmakefile LISP=$(LISP) ACL2_HONS=h ACL2_PAR=p ACL2_REAL=r > make-acl2.log
	./books/build/wait.pl make-acl2.log
	cat make-acl2.log
	./books/build/wait.pl saved_acl2pr
	ls -lah saved_acl2pr

=== books/projects/apply-model-2/Makefile ===
# Target "all" is the top target of Makefile-generic.  We avoid
# including Makefile-subdirs or Makefile-psubdirs because we want to
# be sure to control the order: first this directory, then
# subdirectories.

# At one time we had something like this:

# top: all
# 	$(MAKE) all-subdirs
# all-subdirs: ex1 ex2

# However, I (Matt K.) started seeing surprising (to me) dependency
# errors, perhaps due to some change in GNU Make around version 4.1.
# So now I take care to ensure that all books in the current directory
# are certified before certification is attempted in the
# subdirectories and, moreover, those subdirectories are done
# sequentially (to avoid the parallel recertification of
# e.g. apply-prim.lisp in the present directory on behalf of ex1/ and
# ex2/).

ACL2 ?= ../../../saved_acl2
ACL2_SYSTEM_BOOKS ?= ../..

.PHONY: top ex1 ex2 clean-subdirs clean-Makefile-tmp

top: Makefile-tmp
	@$(MAKE) -s -f Makefile-tmp all ACL2_BOOKS_MAKEFILE=Makefile-tmp
	@$(MAKE) -s ex1
	@$(MAKE) -s ex2

Makefile-tmp : Makefile Makefile-deps
	@echo "Making $(PWD)/Makefile-tmp"
	@cat Makefile Makefile-deps > Makefile-tmp

apply-prim.cert : $(ACL2_SYSTEM_BOOKS)/build/first-order-like-terms-and-out-arities.certdep

include $(ACL2_SYSTEM_BOOKS)/Makefile-generic

ex1:
	@cd ex1 ; $(MAKE) -s

ex2:
	@cd ex2 ; $(MAKE) -s

clean: clean-subdirs clean-Makefile-tmp

clean-Makefile-tmp:
	@rm -f Makefile-tmp

clean-subdirs:
	@cd ex1 ; $(MAKE) -s clean > /dev/null
	@cd ex2 ; $(MAKE) -s clean > /dev/null

=== books/projects/fm9001/Makefile ===
# Cuong Chau

# Usage:

# make JOBS=4 \
#      ACL2=<Path of the ACL2 image>

# To remove certificate files, etc., execute the following:
#
# make clean ACL2=<Path of the ACL2 image>

#======================================================================
.PHONY: all clean
#======================================================================

ifndef ACL2
 $(error Variable ACL2 is undefined.)
endif

BUILD_DIR := $(dir $(ACL2))books/build
JOBS ?= 4

#======================================================================

all:
	$(BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) *.lisp

clean:
	$(BUILD_DIR)/clean.pl

=== books/projects/rac/Makefile ===
export ACL2_DIR?=/Users/davrus01/acl2/
export ACL2?=${ACL2_DIR}/saved_acl2
export RAC?=${ACL2_DIR}/books/projects/rac

all:
	(cd src; make all)
	(cd lisp; make all)

clean:
	(cd lisp; make clean)
	(cd src; make clean)
	(cd examples; make clean)

veryclean: clean
	(cd lisp; make veryclean)
	(cd src; make veryclean)
	(cd examples; make veryclean)

=== books/system/pcert/Makefile ===
# Cause provisional certification in this directory
ACL2_PCERT ?= t
include ../../Makefile-generic
-include Makefile-deps

# Added manually, for the case of provisional certification
# (ACL2_PCERT=t); see last form in .lisp file.
acl2x-pcert-test-2-include.pcert0: acl2x-pcert-test-2.cert

# Override:
acl2x-pcert-test-2.acl2x:
	cp acl2x-pcert-test-2.acl2x-source acl2x-pcert-test-2.acl2x

=== books/system/toothbrush/Makefile ===
# Copyright (C) 2014, ForrestHunt, Inc.
# Written by Matt Kaufmann, November, 2014
# License: A 3-clause BSD license.  See the LICENSE file distributed with ACL2.

# The toothbrush is not part of the normal regression, because a lisp
# must be specified.  That lisp is currently required to be CCL or
# SBCL, because these compile on-the-fly and we load ACL2 source
# files, not compiled files -- though that restriction could possibly
# be removed.

# The next variable, TB_LISP, specifies the Lisp to be used.  We avoid
# using LISP since that is the name used in the main ACL2 GNUmakefile,
# and someone might set it without intending to run toothbrush tests.
# This variable must be set in order to run "make" with this Makefile.
# For regressions, books/GNUmakefile skips running "make" in this
# directory if TB_LISP is not defined.  To run directly in this
# directory, edit one the next lines or designate a Lisp executable
# for TB_LISP in the environment or on the command line.  As explained
# above, only CCL and SBCL are currently supported.

# TB_LISP ?= ccl
# TB_LISP ?= sbcl

# For example:
# make ACL2=/Users/kaufmann/acl2/acl2/saved_acl2 TB_LISP=ccl

ifneq ($(ACL2), $(notdir $(ACL2)))
ACL2_DIR := $(dir $(ACL2))
ACL2_SYSTEM_BOOKS ?= $(ACL2_DIR)books
else
ifneq ($(ACL2_SYSTEM_BOOKS), )
ACL2_DIR := $(dir $(ACL2_SYSTEM_BOOKS)/../)
endif
endif

# Note that ACL2 is typically set by the top-level GNUmakefile for a
# regression, but when using books/GNUmakefile directly, ACL2 is acl2
# by default.  If using cert.pl directly, then this directory will be
# skipped -- one must invoke this Makefile.

success.txt: acl2_check lisp_check defined-syms.lsp make-toothbrush.cert
	@(cd tests ; $(MAKE)) || \
	  (echo "`pwd`/$@: **CERTIFICATION FAILED**"; exit 1)
	@echo "Tests passed." > success.txt

.PHONY: acl2_check
acl2_check:
	@if [ "$(ACL2)" = "" ] ; then \
	echo "ERROR: Environment (or make) variable ACL2 must be";\
	echo "       defined.  It needs to be set to a pathname whose";\
	echo "       directory contains relevant ACL2 source files.";\
	exit 1 ;\
	fi
# The following test avoids failure to set ACL2_SYSTEM_BOOK suitably
# when, for example, specifying ACL2=acl2.
	@if [ "$(ACL2_SYSTEM_BOOKS)" = "" ] ; then \
	echo "ERROR: Environment (or make) variable ACL2_SYSTEM_BOOKS";\
	echo "       must be set.  This may happen automatically if ACL2";\
	echo "       is set not just to an executable, but to a pathname";\
	echo "       whose directory contains relevant ACL2 source files.";\
	exit 1 ;\
	fi
	@echo "Note: For toothbrush, ACL2_DIR = $(ACL2_DIR)."

.PHONY: lisp_check
lisp_check:
	@if [ "$(TB_LISP)" = "" ] ; then \
	echo "ERROR: Environment (or make) variable TB_LISP must be";\
	echo "       defined, to designate a Lisp executable.";\
	exit 1 ;\
	fi

# Note that ACL2_SYSTEM_BOOKS is what defines BOOKS_CERT.
ifneq ($(ACL2_SYSTEM_BOOKS), )
include $(ACL2_SYSTEM_BOOKS)/Makefile-generic
-include Makefile-deps
endif

defined-syms.lsp: acl2_check lisp_check load-toothbrush.lsp make-defined-syms.lsp
	@echo '(defparameter COMMON-LISP-USER::*acl2-dir* "$(ACL2_DIR)") (load "make-defined-syms.lsp") (acl2::exit-lisp)' > workxxx.$@
	@($(TB_LISP) < workxxx.$@ 2>&1) > $@.out
	@echo "Created $@"

# We don't bother with a target for making make-toothbrush.cert, since
# such certification is not necessary.

clean: acl2_check clean-extras clean-tests

.PHONY: clean-extras clean-tests

clean-extras:
	rm -f defined-syms.lsp
	rm -f success.txt

clean-tests:
	cd tests ; $(MAKE) clean

=== books/tools/book-conflicts/Makefile ===

include ../../Makefile-generic
include MOREDEPS

books: conflicts.cert bookdata-types.cert

conflicts.cert: bookdata-types.cert

clean: cleanup

all: conflicts_img books

=== books/xdoc/fancy/Makefile ===
# This is an extremely stupid hack for converting render.xsl into a form that
# can be easily loaded into JavaScript.  There's probably a much better way to
# do this.

all: desktop.css mobile.css render.js

render.js : render.xsl
	echo "var xslt_base64 = \"" > render.tmp
	base64 < render.xsl >> render.tmp
	echo "\";" >> render.tmp
	tr -d '\n' < render.tmp > render.js
	rm render.tmp
	ls -la render.js

# We don't need to convert render-html.xsl, because we don't need it
# in javascript format.


%.css : %.scss
	scss -C --style compact $*.scss $*.css

desktop.css: common.scss
mobile.css: common.scss

=== books/centaur/vl/linttest/Makefile ===
# VL Verilog Toolkit
# Copyright (C) 2008-2014 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean

all:

STARTJOB              ?= bash
VL                    ?= $(PWD)/../bin/vl
VL_LINTTEST_RUBYFLAGS ?=
RUBY                  ?= ruby $(VL_LINTTEST_RUBYFLAGS)

SPEC_FILES := $(wildcard */spec.sv)
TEST_DIRS  := $(patsubst %/spec.sv, %, $(SPEC_FILES))
JSON_FILES := $(patsubst %/spec.sv, %/vl-warnings.json, $(SPEC_FILES))
OK_FILES   := $(patsubst %/spec.sv, %/vl-warnings.ok, $(SPEC_FILES))

%/vl-warnings.json: %/spec.sv $(VL)
	@echo "Making $*/vl-warnings.json"
	@rm -f $*/vl-warnings.json $*/vl-*.txt $*/vl-lint.log
	cd $*; LINTARGS=`if [ -e lintargs ]; then cat lintargs; fi`; $(STARTJOB) -c "$(VL) lint spec.sv $$LINTARGS &> vl-lint.log"
	@ls -l $*/vl-warnings.json

%/vl-warnings.ok: %/vl-warnings.json %/check.rb utils.rb
	@echo "Making $*/vl-warnings.ok"
	@rm -f $*/vl-warnings.ok
	@cd $*; $(STARTJOB) -c "$(RUBY) check.rb &> check.log" || (echo "*** FAIL: $* ***"; cat check.log; false)
	@ls -l $*/vl-warnings.ok

all: $(OK_FILES) $(JSON_FILES)

# Stupid little aliases so you can just type, e.g., "make case" to do the
# testes in the case/ directory.

.PHONY: $(TEST_DIRS)

define mkDirTarget
$(1): $(1)/vl-warnings.ok
endef

$(foreach dir, $(TEST_DIRS), $(eval $(call mkDirTarget, $(dir))))

clean:
	rm -f */vl-*.txt
	rm -f */vl-lint.log
	rm -f */vl-warnings.json
	rm -f */vl-warnings.ok
	rm -f */check.log
	rm -f vl-*.txt vl-warnings.json
	rm -rf */INCA_libs */simv.daidir */simv */csrc */ncverilog.log

=== books/centaur/vl2014/systest/Makefile ===
# VL 2014 -- VL Verilog Toolkit, 2014 Edition
# Copyright (C) 2008-2015 Centaur Technology
#
# Contact:
#   Centaur Technology Formal Verification Group
#   7600-C N. Capital of Texas Highway, Suite 300, Austin, TX 78731, USA.
#   http://www.centtech.com/
#
# License: (An MIT/X11-style license)
#
#   Permission is hereby granted, free of charge, to any person obtaining a
#   copy of this software and associated documentation files (the "Software"),
#   to deal in the Software without restriction, including without limitation
#   the rights to use, copy, modify, merge, publish, distribute, sublicense,
#   and/or sell copies of the Software, and to permit persons to whom the
#   Software is furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
#   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#   AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#   LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
#   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
#   DEALINGS IN THE SOFTWARE.
#
# Original author: Jared Davis <jared@centtech.com>

.PHONY: all clean debug ncv vcs

all: ncv vcs

STARTJOB ?= bash
VL       ?= $(PWD)/../bin/vl2014

SPEC_FILES        := $(wildcard */spec.v)
TEST_DIRS         := $(patsubst %/spec.v, %,                   $(SPEC_FILES))

NCV_V_IMPL_FILES  := $(patsubst %/spec.v, %/impl.ncv.v,        $(SPEC_FILES))
NCV_SV_IMPL_FILES := $(patsubst %/spec.v, %/impl.ncv.sv,       $(SPEC_FILES))
NCV_V_OKS         := $(patsubst %/spec.v, %/ncv.v.ok,          $(SPEC_FILES))
NCV_SV_OKS        := $(patsubst %/spec.v, %/ncv.sv.ok,         $(SPEC_FILES))

ncv: $(NCV_V_IMPL_FILES)
ncv: $(NCV_SV_IMPL_FILES)
ncv: $(NCV_V_OKS)
ncv: $(NCV_SV_OKS)

VCS_V_IMPL_FILES  := $(patsubst %/spec.v, %/impl.vcs.v,        $(SPEC_FILES))
VCS_SV_IMPL_FILES := $(patsubst %/spec.v, %/impl.vcs.sv,       $(SPEC_FILES))
VCS_V_OKS         := $(patsubst %/spec.v, %/vcs.v.ok,          $(SPEC_FILES))
VCS_SV_OKS        := $(patsubst %/spec.v, %/vcs.sv.ok,         $(SPEC_FILES))

vcs: $(VCS_V_IMPL_FILES)
vcs: $(VCS_SV_IMPL_FILES)
vcs: $(VCS_V_OKS)
vcs: $(VCS_SV_OKS)

impls: $(NCV_V_IMPL_FILES) $(NCV_SV_IMPL_FILES) $(VCS_V_IMPL_FILES) $(VCS_SV_IMPL_FILES)

NCV_VERILOG    := ncverilog +access+r      +define+VL_SYSTEST_NCV
NCV_SYSVERILOG := ncverilog +access+r +sv  +define+VL_SYSTEST_NCV +define+SYSTEM_VERILOG_MODE
VCS_VERILOG    := vcs -o simv.v            +define+VL_SYSTEST_VCS
VCS_SYSVERILOG := vcs -o simv.sv -sverilog +define+VL_SYSTEST_VCS +define+SYSTEM_VERILOG_MODE

XLATE_NCV_V    := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.ncv.v  --define=VL_SYSTEST_NCV --edition=Verilog
XLATE_NCV_SV   := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.ncv.sv --define=VL_SYSTEST_NCV --edition=SystemVerilog --define=SYSTEM_VERILOG_MODE
XLATE_VCS_V    := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.vcs.v  --define=VL_SYSTEST_VCS --edition=Verilog
XLATE_VCS_SV   := $(VL) model spec.v --mem=2 --search=. --verilog-file=impl.vcs.sv --define=VL_SYSTEST_VCS --edition=SystemVerilog --define=SYSTEM_VERILOG_MODE

%/impl.ncv.v: %/spec.v $(VL)
	@echo "Making $*/impl.ncv.v"
	@rm -f %/impl.ncv.v %/impl.ncv.v.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.ncv.v.out; $(XLATE_NCV_V) &>> impl.ncv.v.out'
	@ls -l $*/impl.ncv.v

%/impl.ncv.sv: %/spec.v $(VL)
	@echo "Making $*/impl.ncv.sv"
	@rm -f %/impl.ncv.sv %/impl.ncv.sv.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.ncv.sv.out; $(XLATE_NCV_SV) &>> impl.ncv.sv.out'
	@ls -l $*/impl.ncv.sv

%/impl.vcs.v: %/spec.v $(VL)
	@echo "Making $*/impl.vcs.v"
	@rm -f %/impl.vcs.v %/impl.vcs.v.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.vcs.v.out; $(XLATE_VCS_V) &>> impl.vcs.v.out'
	@ls -l $*/impl.vcs.v

%/impl.vcs.sv: %/spec.v $(VL)
	@echo "Making $*/impl.vcs.sv"
	@rm -f %/impl.vcs.sv %/impl.vcs.sv.out
	@cd $*; $(STARTJOB) -c \
	  'echo `hostname` &> impl.vcs.sv.out; $(XLATE_VCS_SV) &>> impl.vcs.sv.out'
	@ls -l $*/impl.vcs.sv

%/ncv.v.ok: %/impl.ncv.v %/spec.v $(wildcard %/compare*.v)
	@echo "Making $*/ncv.v.out"
	@cd $*; $(STARTJOB) -c "$(NCV_VERILOG) compare.v spec.v impl.ncv.v &> ncv.v.out" \
           || (echo "NCV command failed for $*." ;\
	       ../errcheck.pl ncv.v.out ;\
	       false)
	@ls -l $*/ncv.v.out
	@./errcheck.pl $*/ncv.v.out
	@cp $*/ncv.v.out $*/ncv.v.ok

%/ncv.sv.ok: %/impl.ncv.sv %/spec.v $(wildcard %/compare*.v)
	@echo "Making $*/ncv.sv.out"
	@cd $*; $(STARTJOB) -c "$(NCV_SYSVERILOG) compare.v spec.v impl.ncv.sv &> ncv.sv.out" \
           || (echo "NCV command failed for $*." ;\
	       ../errcheck.pl ncv.sv.out ;\
	       false)
	@ls -l $*/ncv.sv.out
	@./errcheck.pl $*/ncv.sv.out
	@cp $*/ncv.sv.out $*/ncv.sv.ok

%/vcs.v.ok: %/impl.vcs.v $(wildcard %/compare*.v)
	@echo "Making $*/vcs.v.out"
	@cd $*; $(STARTJOB) -c "$(VCS_VERILOG) compare.v spec.v impl.vcs.v &> vcs.v.out; ./simv.v &>> vcs.v.out" \
            || (echo "VCS command failed for $*." ;\
	       ../errcheck.pl vcs.v.out ;\
	       false)
	@ls -l $*/vcs.v.out
	@./errcheck.pl $*/vcs.v.out
	@cp $*/vcs.v.out $*/vcs.v.ok

%/vcs.sv.ok: %/impl.vcs.sv $(wildcard %/compare*.v)
	@echo "Making $*/vcs.sv.out"
	@cd $*; $(STARTJOB) -c "$(VCS_SYSVERILOG) compare.v spec.v impl.vcs.sv &> vcs.sv.out; ./simv.sv &>> vcs.sv.out" \
            || (echo "VCS command failed for $*." ;\
	       ../errcheck.pl vcs.sv.out ;\
	       false)
	@ls -l $*/vcs.sv.out
	@./errcheck.pl $*/vcs.sv.out
	@cp $*/vcs.sv.out $*/vcs.sv.ok



# Stupid little aliases so you can just type, e.g., "make case" to do the
# testes in the case/ directory.

.PHONY: $(TEST_DIRS)

define mkDirTarget
$(1): $(1)/ncv.sv.ok
$(1): $(1)/ncv.v.ok
$(1): $(1)/vcs.sv.ok
$(1): $(1)/vcs.v.ok
endef

$(foreach dir, $(TEST_DIRS), $(eval $(call mkDirTarget, $(dir))))




clean:
	rm -f */impl.*.v */impl.*.sv
	rm -f */*.sao */*.sao.ver
	rm -f */*.log */*.out */*.ok
	rm -rf */INCA_libs */*.vcd */*.key
	rm -rf */simv.*.daidir */simv.v */simv.sv
	rm -rf */csrc
	rm -f .joblist */.joblist
	rm -f */*.tem

=== books/kestrel/java/aij/Makefile ===
# Java Library
#
# Copyright (C) 2021 Kestrel Institute (http://www.kestrel.edu)
#
# License: A 3-clause BSD license. See the LICENSE file distributed with ACL2.
#
# Author: Alessandro Coglio (coglio@kestrel.edu)

################################################################################

# This file compiles the Java source files of AIJ without IntelliJ IDEA.
# It generates the class and jar files in the same places as IntelliJ IDEA does.

# This file also generates Javadoc HTML documentation
# for public, package-private, and private classes and members
# (not for protected classes and members
# because AIJ currently does not have any).
# The generated documentation goes into the directories
# javadoc-public, javadoc-package, and javadoc-private,
# from where it can be opened in a browser.

# This file also certifies the ACL2 files in this directory.
# Note that the ACL2 files do not depend on the Java-related files,
# and that the Java-related files do not depend on the ACL2 files.
# This file does not assume cert.pl and clean.pl to be in the path:
# it references them via a relative path from this directory.

# This file assumes that
# a Java 8 (or later) compiler and related tools (e.g. the latest OpenJDK)
# is in the path.

################################################################################

$(info ) # print a blank line

all: aij javadoc-all acl2-files

aij: java/out/artifacts/AIJ_jar/AIJ.jar

java/out/artifacts/AIJ_jar/AIJ.jar: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate class files:"
	mkdir -p java/out/production/AIJ
	javac -d java/out/production/AIJ java/src/edu/kestrel/acl2/aij/*.java
	@echo ""
	@echo "Generate jar file:"
	mkdir -p java/out/artifacts/AIJ_jar
	jar cfm java/out/artifacts/AIJ_jar/AIJ.jar java/META-INF/MANIFEST.MF \
            -C java/out/production/AIJ/ .
	@echo ""

javadoc-all: javadoc-public javadoc-package javadoc-private

javadoc-public: javadoc-public/index.html

javadoc-package: javadoc-package/index.html

javadoc-private: javadoc-private/index.html

javadoc-public/index.html: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate public Javadoc documentation:"
	javadoc -d javadoc-public -public java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

javadoc-package/index.html: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate package Javadoc documentation:"
	javadoc -d javadoc-package -package java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

javadoc-private/index.html: java/src/edu/kestrel/acl2/aij/*.java
	@echo "Generate private Javadoc documentation:"
	javadoc -d javadoc-private -private java/src/edu/kestrel/acl2/aij/*.java
	@echo ""

acl2-files: top.cert

top.cert: top.lisp
	@echo "Certify ACL2 files:"
	../../../build/cert.pl *.lisp
	@echo ""

clean:
	@echo "Delete class files and jar file:"
	/bin/rm -rf java/out
	@echo ""
	@echo "Delete Javadoc HTML files:"
	/bin/rm -rf javadoc-public
	/bin/rm -rf javadoc-package
	/bin/rm -rf javadoc-private
	@echo ""
	@echo "Delete ACL2 certification files:"
	../../../build/clean.pl
	@echo ""

=== books/projects/rac/lisp/Makefile ===
ifndef ACL2
 $(error Variable ACL2 is undefined.)
endif

BUILD_DIR := $(dir $(ACL2))books/build
JOBS ?= 4

all:
	$(BUILD_DIR)/cert.pl -j $(JOBS) -a $(ACL2) *.lisp

# all: translate.cert

# translate.cert: translate.lisp
# 	echo '(certify-book "translate")' | ${ACL2}

clean:

veryclean: clean
	rm -f *.cert *.*x64fsl *.port *.cert.time *.cert.out *.fasl

=== debian/changelog ===
acl2 (8.4dfsg-2) unstable; urgency=medium

  * append make.log to build output

 -- Camm Maguire <camm@debian.org>  Fri, 29 Oct 2021 14:06:33 +0000

acl2 (8.4dfsg-1) unstable; urgency=medium

  * New upstream release
  * Bug fix: "run-acl2 in emacs fails", thanks to florine forine (Closes:
    #987172).

 -- Camm Maguire <camm@debian.org>  Thu, 28 Oct 2021 17:26:09 +0000

acl2 (8.3dfsg-4) unstable; urgency=medium

  * Source only upload to allow testing migration

 -- Camm Maguire <camm@debian.org>  Mon, 11 Oct 2021 12:19:41 +0000

acl2 (8.3dfsg-3) unstable; urgency=medium

  * clean build-depends
  * lintian cleanups
  * acl2-emacs -> elpa-acl2

 -- Camm Maguire <camm@debian.org>  Wed, 03 Feb 2021 18:36:07 +0000

=== debian/control ===
Source: acl2
Section: math
Priority: optional
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: debhelper-compat ( = 13 ), gcl ( >= 2.6.12-92), debhelper ( >= 13), texlive-latex-recommended, time, tex-common, texinfo
Build-Depends-Indep: dh-elpa
Homepage: https://www.cs.utexas.edu/users/moore/acl2/
Rules-Requires-Root: no
Standards-Version: 4.5.1

Package: acl2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: acl2-source, acl2-books
Suggests: elpa-acl2
Description: Computational Logic for Applicative Common Lisp: main binary
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the base ACL2 binary.

Package: acl2-source
Architecture: all
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Depends: ${misc:Depends}
Description: Computational Logic for Applicative Common Lisp: source files
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the lisp source files to the main ACL2 binary.

Package: elpa-acl2
Architecture: all
Depends: acl2 (>= ${source:Version}), emacs-gtk | emacsen, ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Section: lisp
Description: Computational Logic for Applicative Common Lisp: emacs interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains an emacs interface to ACL2.

Package: acl2-infix
Architecture: any
Recommends: acl2-infix-source (= ${source:Version})
Depends: acl2 (= ${binary:Version}), texlive-latex-recommended, ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix interface
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains utilities and libraries to access ACL2 via an
 infix notation similar to that used in many non-lisp programming
 languages.

Package: acl2-infix-source
Architecture: all
Depends: ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: infix source
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the source files to the infix interface to
 ACL2.

Package: acl2-books
Architecture: any
Depends: acl2 (= ${binary:Version}), acl2-books-certs (= ${source:Version}), acl2-books-source (= ${source:Version}), ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: compiled libraries
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains numerous precompiled and precertified libraries
 for use in proving theorems with ACL2.  Serious users will no doubt
 want to install this package.

Package: acl2-books-source
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library sources
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains source lisp files to the compiled libraries
 supplied in the ACL2-books package.

Package: acl2-books-certs
Architecture: all
Depends: acl2 (>= ${source:Version}), ${misc:Depends}
Breaks: acl2 (<= 2.7-9)
Replaces: acl2 (<= 2.7-9)
Description: Computational Logic for Applicative Common Lisp: library certificates
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This file contains certification records for the various precompiled
 libraries supplied in the ACL2-books package.  ACL2 essentially
 requires that all included books be certified before use.

Package: acl2-doc
Depends: ${misc:Depends}, dpkg (>= 1.15.4) | install-info
Architecture: all
Section: doc
Description: Computational Logic for Applicative Common Lisp: documentation
 ACL2 is both a programming language in which you can model computer
 systems and a tool to help you prove properties of those models.
 .
 This package contains the documentation for ACL2.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 by Joey Hess.
#
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independent
# package.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatability version to use.
#export DH_COMPAT=4

# This has to be exported to make some magic below work.
export DH_OPTIONS

PN:=acl2
VR:=$(shell awk '{if (i) next;i=1;a=$$2;gsub("[()]","",a);split(a,A,"-");print A[1];}' debian/changelog)
PD:=$(PN)-$(VR)


NO_STRIP:=
# ifeq ($(DEB_BUILD_ARCH),powerpc)
# NO_STRIP:=--exclude=saved_acl2
# endif

# ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION:=500000000
# MAXJOBS:=$(shell gcl -batch -eval \
#    "(print \
#       (multiple-value-bind (a b c d) (si::heap-report) \
# 	(min 8 \
# 	     (ceiling (/ (- d c) (/ a 8)) \
#                       ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}))))")

NUMJOBS:=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS:=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
# NUMJOBS:=$(shell if test $(NUMJOBS) -gt ${MAXJOBS}; then echo ${MAXJOBS} ; else echo $(NUMJOBS); fi)

#books/workshops:
#	mkdir $@

#init.lsp.ori:
#	[ -e $@ ] || mv init.lsp $@

DLOPEN_T:=debian/dlopen.lisp #init.lsp.ori

#ifeq ($(DEB_BUILD_ARCH),ia64)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),alpha)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mips)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),mipsel)
#DLOPEN?=$(DLOPEN_T)
#endif
#ifeq ($(DEB_BUILD_ARCH),hppa)
#DLOPEN?=$(DLOPEN_T)
#endif

debian/elpa-acl2.elpa: debian/acl2-pkg.el
	find books/interface/emacs -name "*.el" >$@
	find emacs -name "*.el" >>$@
	find books/xdoc -name "*.el" >>$@
	find books/system/doc -name "*.el" >>$@
	find books/emacs -name "*.el" >>$@
	echo debian/acl2.el >> debian/elpa-acl2.elpa
	echo debian/acl2-pkg.el >> debian/elpa-acl2.elpa
	echo debian/debian-autoloads.el >> debian/elpa-acl2.elpa


debian/acl2-pkg.el: debian/acl2-pkg.el.in
	cat $< | sed "s,@VR@,$$(echo $(VR) | sed 's,[a-zA-Z]*,,g'),g" > $@

debian/dlopen.lisp: debian/dlopen.lisp.in
	cat $< | sed "s,@VR@,$(VR),g" > $@

# debian/acl2-emacs.emacsen-startup: debian/acl2-emacs.emacsen-startup.in
# 	cat $< | sed "s,@VR@,$(VR),g" > $@

#pgcl:
#	echo "(progn (setq compiler::*split-files* 100000)(si::save-system \"$@\"))" | GCL_ANSI=t gcl

saved_acl2: # pgcl #debian/patches_applied $(DLOPEN_T)
#	gcl -batch -eval "(bye #-native-reloc 1)" || \
#		(gcl -batch -eval '(load "debian/dlopen.lisp")' && $(MAKE) do_saved)
#	gcl -batch -eval "(bye #+native-reloc 1)" || $(MAKE) GCL_ANSI=t LISP=gcl
	$(MAKE) GCL_ANSI=t LISP=$(shell command -v gcl) & j=$$! ; tail --retry -f make.log & k=$$! ; wait $$j ; kill $$k
	mv *$@.gcl $@

saved_acl2.c: saved_acl2
	echo "(f-put-global 'old-certification-dir \"$$(pwd)/books\" state)" \
              "(f-put-global 'new-certification-dir \"/usr/share/$(PD)/books\" state)" \
	      ":q #-native-reloc (setq si::*multiply-stacks* 4) :q (in-package :acl2) " \
	      "#+(or sparc sparc64)(progn (si::sgc-on nil) (fmakunbound 'si::sgc-on))" \
              "(save-exec \"$@\" \"Modified to produce final certification files\")" | HOME=$$(pwd) ./$<
	mv $@.gcl $@

debian/mini-proveall.out: saved_acl2
	HOME=$$(pwd) $(MAKE) mini-proveall
	mv $(@F) $@

books/short-test.log: saved_acl2.c
	cp saved_acl2 saved_acl2.ori
	HOME=$$(pwd) $(MAKE) certify-books-short
	cp saved_acl2.ori saved_acl2

#	tail -f --pid=$$j --retry $@ $$(find books -name "*.lisp" | sed 's,\.lisp$$,.out,1') & \

debian/test.log: saved_acl2.c
	mv saved_acl2 saved_acl2.ori
	cp $< saved_acl2
#	These take too much memory when run in parallel
	EXCLUDED_PREFIXES="projects/x86isa/machine/instructions kestrel/x86  kestrel/axe" \
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=t \
	$(MAKE) -j $(NUMJOBS) -l 2.95 regression-fresh 2>&1 | tee $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#
	BUILDDIR="$$(dirname $$(pwd))" \
	FINALDIR="/usr/share/$(PD)" \
	HOME=$$(pwd) \
	GCL_MULTIPROCESS_MEMORY_POOL=t \
	$(MAKE) -l 2.95 regression 2>&1 | tee -a $@ & j=$$! ; \
	while sleep 1800; do echo Tick; done & k=$$! ; \
	wait $$j ; kill $$k
#	>$@ 2>&1 & j=$$! ; \
#	while sleep 1800; do echo Tick; done & k=$$! ; tail -f debian/test.log & l=$$! ; \
#	wait $$j ; kill $$k $$l
#	[ -f $@ ] && ! fgrep '**' $@ || (echo FULL TEST FAILS ;\
#		for i in $$(find books -name "*.out"); do \
#			if ! [ -e $${i%out}cert ] ; then \
#				echo $$i ; \
#				cat $$i ; \
#			fi ; \
		done)
	mv saved_acl2.ori saved_acl2
	[ -f $@ ] && ( ! fgrep '**' $@ || true )
	  # gcl -batch -eval \
          #   "(bye \
	  # 	  #-native-reloc 0 \
          #         #+native-reloc \
          #           (let ((w (multiple-value-bind (a b c d) (si::heap-report) (/ (- d c) (/ a 8))))) \
	  # 		 (format t \"certification run with ~s heap words~%\" w) \
	  # 		 (if (< w ${ACL2_HEAP_WORDS_NEEDED_FOR_CERTIFICATION}) 0 1)))")

books/interface/infix/Makefile: books/interface/infix/makefile
	sed -e "s,^DIR = .*,DIR = $$(pwd)/books/interface/infix,1" \
	    -e "s,^LISP = .*,LISP = $$(pwd)/saved_acl2,1" $< > $@

infix-stamp: books/interface/infix/Makefile saved_acl2
	cd books/interface/infix && make -f Makefile compile
	cd books/interface/infix && make -f Makefile example
#	cd books/interface/infix && make -f Makefile events
	touch $@

doc/TEX/acl2-book.ps.gz: saved_acl2
	HOME=$$(pwd) $(MAKE) DOC
	rm -f doc/HTML/LICENSE
	find doc -empty -exec rm {} \;

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: debian/mini-proveall.out debian/test.log infix-stamp # doc/TEX/acl2-book.ps.gz
	dh_testdir

#	$(MAKE)

	touch build-stamp

infix_clean: books/interface/infix/Makefile
	rm -f infix-stamp
	cd books/interface/infix && make -f Makefile clean
	rm -f books/interface/infix/Makefile


debian/dpatches: debian/patches.in
	debian/rules debian/patches_unapplied
	cat $< | sed -e "s,@BDIR@,$$(pwd),1" -e "s,@DDIR@,/usr/share/$(PD),1" >$@

debian/patches_applied: debian/dpatches
	! [ -e debian/patches_unapplied ] || \
		(patch -p1 < $< && rm -f debian/patches_unapplied)
	touch $@

debian/patches_unapplied:
	! [ -e debian/patches_applied ] || ! [ -e debian/dpatches ] ||  \
		(patch -p1 -R < debian/dpatches && rm -f debian/patches_applied)
	touch $@


INSTALLS:=$(addprefix debian/,$(addsuffix .install,acl2 acl2-source acl2-doc acl2-books acl2-books-source acl2-books-certs acl2-infix acl2-infix-source))
LINKS:=$(addprefix debian/,$(addsuffix .links,acl2 acl2-books acl2-infix))
IFILES:=$(INSTALLS) $(shell ls -1 debian/*.examples debian/*.docs)
debian/README.Debian: debian/README.Debian.in $(IFILES)
	awk '/@PLIST@/ {exit 0} {print}' $< >$@
	for i in $(filter %.install,$^); do\
	 awk '/^debian\// {next} {sub(".final$$","",$$1);$$2="/" $$2;print $$0 " " p}' \
		p=$$(basename $${i%.install}) $$i >>$@ ; done
	for i in $(filter %.info,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/info " p}' p=$$(basename $${i%.info}) $$i >>$@ ; done
	for i in $(filter %.examples,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p "/examples " p}' \
		p=$$(basename $${i%.examples}) $$i >>$@ ; done
	for i in $(filter %.docs,$^); do\
	 awk '/^debian\// {next} {print $$0 " /usr/share/doc/" p " " p}' p=$$(basename $${i%.docs}) $$i >>$@ ; done
	awk '/@PLIST@/ {i=1;next} {if (i) print}' $< >>$@

OVERRIDES:= $(shell find debian/ -name "*.lintian-overrides.in" |sed 's,\.in,,g')

clean: infix_clean #debian/patches_unapplied books/workshops
	dh_testdir
	dh_testroot
	rm -f build-stamp

	$(MAKE) clean-all
	$(MAKE) clean-books
	find books -name "*.final" -exec rm {} \;
	rm -f saved_acl2 init_nsaved1_acl2.lsp worklispext
	rm -f debian/mini-proveall.out books/short-test.log debian/test.log
#	! [ -e init.lsp.ori ] || mv init.lsp.ori init.lsp
	rm -f foo.lsp nsaved_acl2
